; makemenu - make a menu from choices.
; Submenus are allowed.
; Copyright (c) 1994 Ann Lynnworth
; updated 3/9/92 aml for Paradox 3.5
; rewritten 8/31/92 aml for Paradox 4.0 
; Showmenu, Showpopup, Showpulldown

If Version() < 4.02 Then
  If Version() < 4 Then
    Quit "Paradox Version 4.00 or higher is required."
  Else
    Beep Sleep 200 Beep
    Message "Paradox Version 4.02 or higher is recommended."
    Sleep 3000
  Endif
Endif


PROC MENU.ASK()
  Private ButtonValue

  ; PaintPAL_Generated_Code_Begin(423340101)

  SHOWDIALOG ""
     PROC "DLG.VALIDATE"
        TRIGGER "ACCEPT"

     @2,6 HEIGHT 19 WIDTH 66

     PAINTCANVAS ATTRIBUTE 79 1,10,4,54

     ; PaintPAL_Frame_Begin
     FRAME SINGLE FROM 1,9 TO 4,55
     PAINTCANVAS BORDER ATTRIBUTE 79 1,9,4,55
     ; PaintPAL_Frame_End

     ; PaintPAL_Frame_Begin
     FRAME SINGLE FROM 12,5 TO 16,26
     PAINTCANVAS ATTRIBUTE 127 12,5,12,26
     PAINTCANVAS ATTRIBUTE 127 12,5,16,5
     PAINTCANVAS ATTRIBUTE 112 16,6,16,26
     PAINTCANVAS ATTRIBUTE 112 12,26,16,26
     ; PaintPAL_Frame_End

     ; PaintPAL_Static_Text_Begin
     PAINTCANVAS FILL " " ATTRIBUTE 112 6,3,6,17
     @6,3
     ?? " Name of Menu "
     PAINTCANVAS ATTRIBUTE 112 6,3,6,17
     ; PaintPAL_Static_Text_End

     ; PaintPAL_Static_Text_Begin
     PAINTCANVAS FILL " " ATTRIBUTE 112 8,3,8,21
     @8,3
     ?? " Application Title "
     PAINTCANVAS ATTRIBUTE 112 8,3,8,21
     ; PaintPAL_Static_Text_End

     ; PaintPAL_Static_Text_Begin
     PAINTCANVAS FILL " " ATTRIBUTE 112 10,3,10,22
     @10,3
     ?? " Autolib (optional) "
     PAINTCANVAS ATTRIBUTE 112 10,3,10,22
     ; PaintPAL_Static_Text_End

     ; PaintPAL_Static_Text_Begin
     PAINTCANVAS FILL " " ATTRIBUTE 79 2,12,2,52
     @2,12
     ?? " Ann Lynnworth's Practical PAL Seminar "
     PAINTCANVAS ATTRIBUTE 79 2,12,2,52
     ; PaintPAL_Static_Text_End

     ; PaintPAL_Static_Text_Begin
     PAINTCANVAS FILL " " ATTRIBUTE 79 3,22,3,45
     @3,22
     ?? " PAL 4.0 Menu Generator "
     PAINTCANVAS ATTRIBUTE 79 3,22,3,45
     ; PaintPAL_Static_Text_End

     ACCEPT @6,26 WIDTH 11
        "a8"
        PICTURE "*!"
        TAG ""
        TO menu.name

     ACCEPT @8,26 WIDTH 35
        "A32"
        PICTURE "&*@"
        TAG ""
        TO menu.title

     ACCEPT @10,26 WIDTH 35
        "a80"
        PICTURE "*!"
        TAG ""
        TO menu.autolib

     RADIOBUTTONS @13,7 HEIGHT 3 WIDTH 18
        "ShowPopup",
        "ShowPullDown",
        "ShowMenu"
        TAG ""
        TO RadioValue

     PUSHBUTTON @14,35 WIDTH 12
        "~C~ontinue"
        OK 
        VALUE ""
        TAG ""
        TO ButtonValue

     PUSHBUTTON @14,51 WIDTH 10
        "Escape"
        CANCEL 
        VALUE ""
        TAG ""
        TO ButtonValue
  ENDDIALOG

  ; PaintPAL_Generated_Code_End(423340101)

ENDPROC

PROC DLG.VALIDATE( a, b, c, d )
  Private choice

  If IsBlank( menu.name ) Then
    Message "Please fill in the name of the menu script to generate"
    Return FALSE
  Endif
    
  menutable  = menu.name         ; this is table name, w/out extension
  scriptfile = menu.name + ".sc"

  ; first validate menu/script/table name
  IF IsTable(menutable) THEN
    MESSAGE menutable, " already exists."
    BEEP
    Showmenu
      "UseIt"     : "Use the existing menu as a base, make changes, and then regenerate script" ,
      "StartOver" : "Replace the existing menu" ,
      "Different" : "Choose a different menu name" ,
      "Quit"      : "Quit this program"
    to choice
    Switch
      CASE choice = "Quit" :
        CancelDialog
        Return FALSE
      CASE choice = "Esc" :
        Return FALSE            ; don't cancel dialog box
      CASE choice = "StartOver" :
        Delete menutable
      CASE choice = "Different" :
        Return FALSE
    Endswitch
  Endif

  If IsBlank( menu.title ) Then
    Message "Please fill in the name of the application title"
    Return FALSE
  Endif

  Return TRUE  
ENDPROC

PROC MAKEMENU()
  Private menu.name, menu.title, scriptfile, menutable, mtbl, x, xx,
          wait.msg, RadioValue, menu.type
          
  
  ; bring back variables from previous session if available
  If IsFile( Privdir() + "menuvars.sc" ) Then
    play Privdir()+"menuvars"
  Endif
  
  MENU.ASK()
  If NOT retval Then
    Return
  Endif
  
  Message "One moment please"

  Switch
    CASE RadioValue = 1 :
      menu.type = "ShowPopup"
    CASE RadioValue = 2 :
      menu.type = "ShowPulldown"
    CASE RadioValue = 3 :
      menu.type = "ShowMenu"
  Endswitch
  
  ; initialize
  mtbl = Sdir()+"make4"

  ; lock tables
  Lock mtbl FL
  If NOT retval Then
    Return FALSE
  Endif
  Lock menutable FL
  If NOT retval Then
    Unlock mtbl FL
    Return FALSE
  Endif

  If NOT IsTable( menutable ) Then
    Create menutable Like mtbl
    {Tools} {Copy} {JustFamily} Select mtbl Select menutable {Replace}
  Endif
  Unlock mtbl FL

  View menutable
  Editkey
  If menu.type = "ShowMenu" Then
    Pickform 2     ; only goes one level deep
  Else
    Pickform 1     ; goes three levels deep for nested menus
  Endif
  wait.msg = ""
  
  Showpulldown
  Endmenu
  Setcanvas Default
  Clear
  
  WHILE (true)
    WAIT TABLE
      Prompt "Define menu. Ctrl-Ins=Copy Record  Shift-Ins=Paste  F2=Generate  Esc=Cancel."
      Message wait.msg
    UNTIL "F2","Esc", -4, -5
    Switch
      CASE retval = "Esc" :
        CancelEdit
        ClearImage
        ClearPullDown
        Unlock menutable FL
        Return FALSE
      CASE retval = "F2" :
        Do_it!
        If SysMode() = "Main" Then
          Quitloop
        Endif
      CASE retval = -4 :    ; ctrl-Ins
        Copytoarray xx
        wait.msg = "Record copied"
        Loop
      CASE retval = -5 :    ; shift-Ins
        If IsAssigned( xx[1] ) Then
          Ins
          Copyfromarray xx
          wait.msg = "New record inserted with saved data"
        Endif
        Loop
    Endswitch
  ENDWHILE
  ClearPullDown
  
  Message "Generating your PAL code for " + menu.name + " script"
  GENERATE.MENU()
  
  ClearAll
  Unlock menutable FL

  SaveVars menu.name, menu.title, menu.autolib, menu.type, RadioValue

  {Tools}{Copy}{Script} Select privdir()+"savevars"  Select privdir()+"menuvars"
  If menuchoice() = "Cancel" then {replace} Endif

  Message scriptfile + " is ready and waiting!!! -- press a key"
  x = getchar()
ENDPROC

PROC WRITE( S )
  PRINT FILE scriptfile S
ENDPROC


PROC GENERATE.MENU()
  Private tab1, tab2, tab3, tab4, option
  
  ; erase any existing menu script so that we don't just keep
  ; appending, and appending, and appending to that same old file!
  If IsFile( scriptfile ) Then
    {Tools} {Delete} {Script} Select menutable {Ok}
  Endif

  ; define tab sizes
  tab1 = "  "
  tab2 = "    "
  tab3 = "      "
  tab4 = tab3+tab2

  ; script header
  WRITE( "; " + scriptfile + "\n" )
  WRITE( "; Created by Ann Lynnworth's MakeMenu Utility\n" )
  WRITE( "; " + Format( "D2", today() ) + " at " + time() + "\n" )
  WRITE( "; Menu type: " + menu.type + "\n" )
  WRITE( "\n\n" )

  ; test for correct version of Paradox
  WRITE( "If Version() < 4 Then\n" )
  WRITE( "  Quit\n" )
  WRITE( "Endif\n\n" )
  
  ; setup phase
  WRITE( "AltSpace {Desktop} {Empty}\n" )
  WRITE( "Release Vars All\n" )
  WRITE( "SetCanvas Default\n" )
  WRITE( "Cursor Off\n" )
  WRITE( "{Tools} {More} {Protect} {ClearPasswords}\n" )
  
  Showmenu
    "Setdir" : "Include the command 'Setdir sdir()' at the beginning of the script",
    "Don't"  : "Omit that line!"
  to s.choice
  
  If s.choice = "Setdir" Then
    WRITE( "Setdir Sdir()      ; align working directory with location of this script\n" )
  Endif
  
  If NOT IsBlank( menu.autolib ) Then
    WRITE( "Autolib = " + chr(34) + menu.autolib + chr(34) + "\n" )
  Endif
  WRITE( "g_menu.msg = \"\"\n" )
  WRITE( "\n" )

  WRITE( "If Version() < 4.02 Then\n" )
  WRITE( "  g_menu.msg = \"Paradox Version 4.02 or higher is recommended.\"\n" )
  WRITE( "Endif\n\n" )
  
  If Search( "DESK40", menu.autolib ) > 0 Then
    WRITE( "Calendar.Constructor()    ; initialize desktop calendar \n\n" )
  Endif
  
  WRITE( "If IsFile( \"moreinit.sc\" ) Then\n" )
  WRITE( "  play \"moreinit\"\n" )
  WRITE( "  If NOT retval Then\n" )
  WRITE( "    Quit\n" )
  WRITE( "   Endif\n" )
  WRITE( "Endif\n\n" )
  
  ; While Loop
  WRITE( "While TRUE\n" )
  
  WRITE( tab1 + "SetCanvas Default\n" )
  WRITE( tab1 + "Clear\n" )
  WRITE( tab1 + "If IsAssigned( g_menu.msg ) Then\n" )
  WRITE( tab2 + "Message g_menu.msg\n" )
  WRITE( tab2 + "g_menu.msg = \"\"\n" )
  WRITE( tab1 + "Endif\n\n" )

  If menu.type = "ShowPulldown" Then
    WRITE( tab1 + "Dynarray x[]\n" )
    WRITE( tab1 + "x[\"HASFRAME\"] = false\n" )
    WRITE( tab1 + "x[\"STYLE\"] = SysColor(17)\n" )
    WRITE( tab1 + "Window Create Floating @7,9 Height 5 Width 60\n" )
    WRITE( tab2 + "Attributes x to wh\n" )
    WRITE( tab1 + "@2,0 ?? Format( \"W58,AC\", " + chr(34) + menu.title +
      chr(34) + ")\n\n" )
  Endif
  
  Switch
    CASE menu.type = "ShowPulldown" :
      WRITE( tab1 + "ShowPulldown\n" )
    CASE menu.type = "ShowPopup" :
      WRITE( tab1 + "ShowPopup " + chr(34) + menu.title + chr(34) +
             " Centered\n" )
    CASE menu.type = "ShowMenu" :
      WRITE( tab1 + "Showmenu" )
  Endswitch
  
Moveto Record 1
WHILE NOT EOT()

  ; **** LEVEL 1 ****
  WRITE( tab2 + chr(34) +[MenuLevel1]+"\" :"+" \""+[description]+"\"" )
  If menu.type <> "ShowMenu" Then
    WRITE( " : " + chr(34) + [MenuLevel1] + chr(34) )
  Endif

  If menu.type <> "ShowMenu" AND [What To Do] = "submenu" Then
        WRITE( "\n" )
        WRITE( tab2 + "SUBMENU\n" )
        Skip

    ; **** LEVEL 2 ****
    While NOT EOT() AND IsBlank( [MenuLevel1] )
      WRITE( tab3 + chr(34) + [MenuLevel2]+"\" :"+" \""+[description]+"\""+
        " : " + chr(34) + [MenuLevel2] + chr(34) )

      If [What To Do] = "submenu" Then
        WRITE( "\n" )
        WRITE( tab3 + "SUBMENU\n" )
        Skip

        ; **** LEVEL 3 ****
        While NOT EOT() AND IsBlank([MenuLevel2])
          WRITE( tab4 + chr(34) + [MenuLevel3]+"\" :"+" \""+[description]+"\""+
          " : " + chr(34) + [MenuLevel3] + chr(34) )
          Skip
          If NOT EOT() AND IsBlank([MenuLevel2]) Then
              If IsBlank( [MenuLevel1] ) Then
                WRITE( ",\n" )
              Else
                WRITE( "\n" )
                Quitloop
              Endif
          Else
            WRITE( "\n" )
            Quitloop
          Endif
        Endwhile
        WRITE( tab3 + "ENDSUBMENU" )
        If NOT EOT() AND IsBlank( [MenuLevel1] ) Then
          WRITE( ",\n" )
        Else
          WRITE( "\n" )
        Endif
      Else
        If NOT IsBlank( [MenuLevel2] ) Then
          Skip
          If NOT EOT() AND IsBlank( [MenuLevel1] ) Then
            WRITE( "," + "\n" )
          ELSE
            WRITE( "\n" )
          ENDIF
        Endif
      Endif
    Endwhile
    WRITE( tab2 + "ENDSUBMENU" )
  Else
    Skip
  Endif
  If NOT EOT() Then
    WRITE( "," + "\n" )
  ELSE
    WRITE( "\n" )
  ENDIF
ENDWHILE

  If menu.type <> "ShowMenu" Then
    WRITE( tab1 + "Endmenu\n" )
  Endif
  If menu.type <> "ShowPulldown" Then
    WRITE( tab1 + "to choice\n" )
  Endif
  WRITE( "\n" )

  Switch
    CASE menu.type = "ShowPopup" :
      WRITE( tab1 + "SetCanvas Default\n" )
      WRITE( tab1 + "Clear\n\n" )
    CASE menu.type = "ShowPulldown" :
;      If Username() = "ANN" Then
; custom for John Silvi at PAHO !!!
;        WRITE( tab1 + "MENU.DISABLE( \"" + menu.name + "\" )\n\n" )
;      Endif
      WRITE( tab1 + "While TRUE\n" )
      WRITE( tab2 + "GetMenuSelection to choice\n" )
      WRITE( tab2 + "If retval Then Quitloop Endif\n" )
      WRITE( tab1 + "Endwhile\n\n" )
      WRITE( tab1 + "ClearPullDown\n\n" )
      WRITE( tab1 + "Window Select wh\n" )
      WRITE( tab1 + "Window Close\n\n" )
      WRITE( tab1 + "SetCanvas Default\n\n" )
  Endswitch
  
  ; **** Switch statement ****
  WRITE( "  Switch\n" )
  WRITE( "    CASE choice = \"Esc\" :\n" )
  WRITE( "      Quitloop\n" )
  Moveto Record 1

WHILE NOT EOT()

  If [what to do] = "submenu" Then
    Skip
    Loop
  Endif

  option = [MenuLevel1] + [MenuLevel2] + [MenuLevel3]
  WRITE( "    CASE choice = "+ chr(34) + option + chr(34) +" :\n" )
  WRITE( "      " + [what to do] + "\n" )
  Skip
ENDWHILE
WRITE( "  Endswitch\nEndwhile \n\n" )

  WRITE( "Release Vars All\n" )
  WRITE( "Unlock All\n" )
  WRITE( "{Tools} {More} {Protect} {ClearPasswords}\n" )
  
ENDPROC



MAKEMENU()


Release Procs MAKEMENU, GENERATE.MENU, MENU.ASK, DLG.VALIDATE
